#ifndef COMMON_H
#define COMMON_H

#include <iostream>
#include <string>

#include <CL/cl.h>

#define PRECISION float

#define OCL_CHECK(code) \
{ \
	oclCheck((code), __FILE__, __LINE__); \
}

#define OCL_CODE_TO_STRING(code) \
{ \
	case code: \
		return #code; \
}

inline const std::string openclGetErrorString(const cl_int code)
{
	switch (code)
    {
		OCL_CODE_TO_STRING(CL_SUCCESS)
		OCL_CODE_TO_STRING(CL_DEVICE_NOT_FOUND)
		OCL_CODE_TO_STRING(CL_DEVICE_NOT_AVAILABLE)
		OCL_CODE_TO_STRING(CL_COMPILER_NOT_AVAILABLE)
		OCL_CODE_TO_STRING(CL_MEM_OBJECT_ALLOCATION_FAILURE)
		OCL_CODE_TO_STRING(CL_OUT_OF_RESOURCES)
		OCL_CODE_TO_STRING(CL_OUT_OF_HOST_MEMORY)
		OCL_CODE_TO_STRING(CL_PROFILING_INFO_NOT_AVAILABLE)
		OCL_CODE_TO_STRING(CL_MEM_COPY_OVERLAP)
		OCL_CODE_TO_STRING(CL_IMAGE_FORMAT_MISMATCH)
		OCL_CODE_TO_STRING(CL_IMAGE_FORMAT_NOT_SUPPORTED)
		OCL_CODE_TO_STRING(CL_BUILD_PROGRAM_FAILURE)
		OCL_CODE_TO_STRING(CL_MAP_FAILURE)
		OCL_CODE_TO_STRING(CL_MISALIGNED_SUB_BUFFER_OFFSET)
		OCL_CODE_TO_STRING(CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST)
		OCL_CODE_TO_STRING(CL_COMPILE_PROGRAM_FAILURE)
		OCL_CODE_TO_STRING(CL_LINKER_NOT_AVAILABLE)
		OCL_CODE_TO_STRING(CL_LINK_PROGRAM_FAILURE)
		OCL_CODE_TO_STRING(CL_DEVICE_PARTITION_FAILED)
		OCL_CODE_TO_STRING(CL_KERNEL_ARG_INFO_NOT_AVAILABLE)
		OCL_CODE_TO_STRING(CL_INVALID_VALUE)
		OCL_CODE_TO_STRING(CL_INVALID_DEVICE_TYPE)
		OCL_CODE_TO_STRING(CL_INVALID_PLATFORM)
		OCL_CODE_TO_STRING(CL_INVALID_DEVICE)
		OCL_CODE_TO_STRING(CL_INVALID_CONTEXT)
		OCL_CODE_TO_STRING(CL_INVALID_QUEUE_PROPERTIES)
		OCL_CODE_TO_STRING(CL_INVALID_COMMAND_QUEUE)
		OCL_CODE_TO_STRING(CL_INVALID_HOST_PTR)
		OCL_CODE_TO_STRING(CL_INVALID_MEM_OBJECT)
		OCL_CODE_TO_STRING(CL_INVALID_IMAGE_FORMAT_DESCRIPTOR)
		OCL_CODE_TO_STRING(CL_INVALID_IMAGE_SIZE)
		OCL_CODE_TO_STRING(CL_INVALID_SAMPLER)
		OCL_CODE_TO_STRING(CL_INVALID_BINARY)
		OCL_CODE_TO_STRING(CL_INVALID_BUILD_OPTIONS)
		OCL_CODE_TO_STRING(CL_INVALID_PROGRAM)
		OCL_CODE_TO_STRING(CL_INVALID_PROGRAM_EXECUTABLE)
		OCL_CODE_TO_STRING(CL_INVALID_KERNEL_NAME)
		OCL_CODE_TO_STRING(CL_INVALID_KERNEL_DEFINITION)
		OCL_CODE_TO_STRING(CL_INVALID_KERNEL)
		OCL_CODE_TO_STRING(CL_INVALID_ARG_INDEX)
		OCL_CODE_TO_STRING(CL_INVALID_ARG_VALUE)
		OCL_CODE_TO_STRING(CL_INVALID_ARG_SIZE)
		OCL_CODE_TO_STRING(CL_INVALID_KERNEL_ARGS)
		OCL_CODE_TO_STRING(CL_INVALID_WORK_DIMENSION)
		OCL_CODE_TO_STRING(CL_INVALID_WORK_GROUP_SIZE)
		OCL_CODE_TO_STRING(CL_INVALID_WORK_ITEM_SIZE)
		OCL_CODE_TO_STRING(CL_INVALID_GLOBAL_OFFSET)
		OCL_CODE_TO_STRING(CL_INVALID_EVENT_WAIT_LIST)
		OCL_CODE_TO_STRING(CL_INVALID_EVENT)
		OCL_CODE_TO_STRING(CL_INVALID_OPERATION)
		OCL_CODE_TO_STRING(CL_INVALID_GL_OBJECT)
		OCL_CODE_TO_STRING(CL_INVALID_BUFFER_SIZE)
		OCL_CODE_TO_STRING(CL_INVALID_MIP_LEVEL)
		OCL_CODE_TO_STRING(CL_INVALID_GLOBAL_WORK_SIZE)
		OCL_CODE_TO_STRING(CL_INVALID_PROPERTY)
		OCL_CODE_TO_STRING(CL_INVALID_IMAGE_DESCRIPTOR)
		OCL_CODE_TO_STRING(CL_INVALID_COMPILER_OPTIONS)
		OCL_CODE_TO_STRING(CL_INVALID_LINKER_OPTIONS)
		OCL_CODE_TO_STRING(CL_INVALID_DEVICE_PARTITION_COUNT)
		default:
			return "Unknown OpenCL error";
    }
}

inline bool oclCheck(const cl_int code, const std::string file, const int line, const bool abort = false)
{
	if (code != CL_SUCCESS)
	{
		std::cerr << "----- !!! The following OpenCL error occurred !!! -----" << std::endl;
		std::cerr << "error code:     " << code << std::endl;
		std::cerr << "error string:   " << openclGetErrorString(code) << std::endl;
		std::cerr << "error location: " << file << ":" << line << std::endl;
		std::cerr << "-------------------------------------------------------" << std::endl;

		if(abort)
			exit(code);

		return false;
	}

	return (code == CL_SUCCESS);
}

#endif
